#include <string>
#include <iostream>
#include <GL/glut.h>
#include "../map.h"
#include "../node.h"
#include "graphics.h"
#define BLOCKWIDTH 15
using namespace std;
Map *map;
void draw(){
	glClear(GL_COLOR_BUFFER_BIT);
	for(int x = 0; x < 50; x++){
		for(int y  = 0; y < 50; y++){
			glBegin(GL_POLYGON);
			glColor3f(map->getNode(x,y)->red,map->getNode(x,y)->green,map->getNode(x,y)->blue);
			glVertex2i(x*BLOCKWIDTH, y*BLOCKWIDTH);
			glColor3f(map->getNode(x,y)->red,map->getNode(x,y)->green,map->getNode(x,y)->blue);
			glVertex2i(x*BLOCKWIDTH+BLOCKWIDTH, y*BLOCKWIDTH);
			glColor3f(map->getNode(x,y)->red,map->getNode(x,y)->green,map->getNode(x,y)->blue);
			glVertex2i(x*BLOCKWIDTH+BLOCKWIDTH, y*BLOCKWIDTH+BLOCKWIDTH);
			glColor3f(map->getNode(x,y)->red,map->getNode(x,y)->green,map->getNode(x,y)->blue);
			glVertex2i(x*BLOCKWIDTH, y*BLOCKWIDTH+BLOCKWIDTH);
			glEnd();
			}
		}
	glFlush();
	}
void reshape(int w, int h){
	glViewport(0, 0, w, h);       /* Establish viewing area to cover entire window. */
	glMatrixMode(GL_PROJECTION);  /* Start modifying the projection matrix. */
	glLoadIdentity();             /* Reset project matrix. */
	glOrtho(0, w, 0, h, -1, 1);   /* Map abstract coords directly to window coords. */
	glScalef(1, -1, 1);           /* Invert Y axis so increasing Y goes down. */
	glTranslatef(0, -h, 0);       /* Shift origin up to upper-left corner. */
	}
Graphics::Graphics(int *argc, char **argv, Map *m){
	map = m;
	glutInit(argc, argv);
	glutInitWindowSize(50*BLOCKWIDTH, 50*BLOCKWIDTH);
	glutCreateWindow("Dragonblocks");
	glutDisplayFunc(draw);
	glutReshapeFunc(reshape);
	glutMainLoop();
	}
